StringParser (Tomcat API Documentation)
Keywords: org.apache.catalina.util.StringParser class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.util
Class StringParser

    java.lang.Object
      org.apache.catalina.util.StringParser

    public final class StringParser

extends java.lang.Object

Utility class for string parsing that is higher performance than StringParser for simple delimited text cases. Parsing is performed by setting the string, and then using the `findXxxx()` and `skipXxxx()` families of methods to remember significant offsets. To retrieve the parsed substrings, call the `extract()` method with the appropriate saved offset values.

Version:
  $Revision: 467222 $ $Date: 2006-10-24 05:17:11 +0200 (Tue, 24 Oct 2006) $
Author:
  Craig R. McClanahan

Constructor Summary
`StringParser()` Construct a string parser with no preset string to be parsed.
`StringParser(java.lang.String string)` Construct a string parser that is initialized to parse the specified string.

Method Summary
`void` | `advance()` Advance the current parsing position by one, if we are not already past the end of the string.
`java.lang.String` | `extract(int start)` Extract and return a substring that starts at the specified position, and extends to the end of the string being parsed.
`java.lang.String` | `extract(int start, int end)` Extract and return a substring that starts at the specified position, and ends at the character before the specified position.
`int` | `findChar(char ch)` Return the index of the next occurrence of the specified character, or the index of the character after the last position of the string if no more occurrences of this character are found.
`int` | `findText()` Return the index of the next occurrence of a non-whitespace character, or the index of the character after the last position of the string if no more non-whitespace characters are found.
`int` | `findWhite()` Return the index of the next occurrence of a whitespace character, or the index of the character after the last position of the string if no more whitespace characters are found.
`int` | `getIndex()` Return the zero-relative index of our current parsing position within the string being parsed.
`int` | `getLength()` Return the length of the string we are parsing.
`java.lang.String` | `getString()` Return the String we are currently parsing.
`protected boolean` | `isWhite(char ch)` Is the specified character considered to be whitespace?
`void` | `reset()` Reset the current state of the parser to the beginning of the current string being parsed.
`void` | `setString(java.lang.String string)` Set the String we are currently parsing.
`int` | `skipChar(char ch)` Advance the current parsing position while it is pointing at the specified character, or until it moves past the end of the string.
`int` | `skipText()` Advance the current parsing position while it is pointing at a non-whitespace character, or until it moves past the end of the string.
`int` | `skipWhite()` Advance the current parsing position while it is pointing at a whitespace character, or until it moves past the end of the string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StringParser

    public StringParser()

  Construct a string parser with no preset string to be parsed.

### StringParser

    public StringParser(java.lang.String string)

  Construct a string parser that is initialized to parse the specified string.

  Parameters:
    `string` - The string to be parsed

Method Detail

### getIndex

    public int getIndex()

  Return the zero-relative index of our current parsing position within the string being parsed.

### getLength

    public int getLength()

  Return the length of the string we are parsing.

### getString

    public java.lang.String getString()

  Return the String we are currently parsing.

### setString

    public void setString(java.lang.String string)

  Set the String we are currently parsing. The parser state is also reset to begin at the start of this string.

  Parameters:
    `string` - The string to be parsed.

### advance

    public void advance()

  Advance the current parsing position by one, if we are not already past the end of the string.

### extract

    public java.lang.String extract(int start)

  Extract and return a substring that starts at the specified position, and extends to the end of the string being parsed. If this is not possible, a zero-length string is returned.

  Parameters:
    `start` - Starting index, zero relative, inclusive

### extract

    public java.lang.String extract(int start,
                                    int end)

  Extract and return a substring that starts at the specified position, and ends at the character before the specified position. If this is not possible, a zero-length string is returned.

  Parameters:
    `start` - Starting index, zero relative, inclusive
    `end` - Ending index, zero relative, exclusive

### findChar

    public int findChar(char ch)

  Return the index of the next occurrence of the specified character, or the index of the character after the last position of the string if no more occurrences of this character are found. The current parsing position is updated to the returned value.

  Parameters:
    `ch` - Character to be found

### findText

    public int findText()

  Return the index of the next occurrence of a non-whitespace character, or the index of the character after the last position of the string if no more non-whitespace characters are found. The current parsing position is updated to the returned value.

### findWhite

    public int findWhite()

  Return the index of the next occurrence of a whitespace character, or the index of the character after the last position of the string if no more whitespace characters are found. The current parsing position is updated to the returned value.

### reset

    public void reset()

  Reset the current state of the parser to the beginning of the current string being parsed.

### skipChar

    public int skipChar(char ch)

  Advance the current parsing position while it is pointing at the specified character, or until it moves past the end of the string. Return the final value.

  Parameters:
    `ch` - Character to be skipped

### skipText

    public int skipText()

  Advance the current parsing position while it is pointing at a non-whitespace character, or until it moves past the end of the string. Return the final value.

### skipWhite

    public int skipWhite()

  Advance the current parsing position while it is pointing at a whitespace character, or until it moves past the end of the string. Return the final value.

### isWhite

    protected boolean isWhite(char ch)

  Is the specified character considered to be whitespace?

  Parameters:
    `ch` - Character to be checked

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.